shared float4x4			mViewProj;
shared float4x4			mView;
shared float4x4			mProj;
float4x4		mWorldViewProj;
float4x4		mWorldView;
float4x4		mWorld;

float3			vScale;
float			fDiffuse;
float4			vSpecular;
sampler			sSampler0 : register(s0);


void VS_Transform(
	float4		inPosition	: POSITION,
	float4		inColor		: COLOR0,
	float3		inNormal	: NORMAL,
	float2		inTex		: TEXCOORD0,
	out float4	outPosition	: POSITION,
	out float4	outDiffuse	: COLOR0,
	out float4	outSpecular	: COLOR1,
	out float2	outTex		: TEXCOORD0
)
{
	float4 pos = mul(inPosition * float4(vScale, 1), mWorld);

	// Wϊ
	outPosition = mul(pos, mViewProj);
	
	outDiffuse = inColor * fDiffuse;//0.5;
	//outDiffuse.x = inColor * fDiffuse * fDiffuse;
	//outDiffuse.y = inColor * fDiffuse * fDiffuse;
	
	float3 dir = {-1, 0, -1};
	//outSpecular = 0;
	//outSpecular = (0.5 + dot(mul(inNormal, (float3x3)mWorld), dir)) * 0.25;
	outSpecular = 0;//(dot(mul(inNormal, (float3x3)mWorldView), dir)) * 0.25;
	
	// eNX`W𒲐
	outTex = inTex;
}


float4 PS_Main(
	float4 inTex : TEXCOORD0, 
	float4 inDiffuse : COLOR0, 
	float4 inSpecular : COLOR1) : COLOR0
{
	float a = tex2D(sSampler0, inTex).a;
	float4 base = {0.1, 0.2, 0.6, 0.8};
	float4 ret = a * inDiffuse.a * base;
	//ret.a = inDiffuse.r;
	return ret + inSpecular;
}


technique
{
	pass
	{
		SpecularEnable = TRUE;
		AlphaBlendEnable = TRUE;
		SrcBlend = SRCALPHA;
		DESTBLEND = INVSRCALPHA;
		AlphaTestEnable = FALSE;
		ZWriteEnable = FALSE;
		VertexShader = compile vs_1_1 VS_Transform();
		PixelShader = compile ps_2_0 PS_Main();
	}
}

