

static const int		MAX_MATRICES = 16;				// s̍ő吔
bool					bEnableSkinning = false;		// XLjO

shared float4x4			mWorldViewProj;
float4x4				mBoneMatrices[MAX_MATRICES];	// {[̍s

float4					vGlowColor = {1.0, 1.0, 1.0, 1.0};
float2					vOffsets[8];
float					fWeights[8];	// d
sampler					sampler0;



//=====================================================================
// VertexShader: Ă镔`悷
//=====================================================================
void VS_GlowEffect(float4		inPosition		: POSITION,
				   float2		inTex			: TEXCOORD,
				   float3		inWeights		: BLENDWEIGHT,
				   float4		inIndices		: BLENDINDICES,
				   out float4	outPosition		: POSITION,
				   out float2	outTex			: TEXCOORD0)
{

	// XLjO̗LŃu`
	if (bEnableSkinning)
	{
		float4 worldPos = mul(inPosition, mBoneMatrices[inIndices.x]) * inWeights.x + 
							mul(inPosition, mBoneMatrices[inIndices.y]) * inWeights.y + 
							mul(inPosition, mBoneMatrices[inIndices.z]) * inWeights.z + 
							mul(inPosition, mBoneMatrices[inIndices.w]) * (1.0 - inWeights.x - inWeights.y - inWeights.z);
		outPosition = mul(worldPos, mWorldViewProj);
	}
	else
	{
		outPosition = mul(inPosition, mWorldViewProj);
	}

	outTex = inTex;
}


//=====================================================================
// PixelShader: Ă镔`悷
//=====================================================================
float4 PS_GlowEffect(float4		inColor		: COLOR0,
					 float2		inTex		: TEXCOORD): COLOR0
{
	float4 ret = vGlowColor;
	
	ret.a += tex2D(sampler0, inTex).a;
	
	return ret;
}


//=====================================================================
// VertexShader: ڂ
//=====================================================================
void VS_Blur(float4			inPosition		: POSITION,
			 float2			inTex			: TEXCOORD,
			 out float4		outPosition		: POSITION,
			 out float2		outTex0			: TEXCOORD0)
{
	outPosition = inPosition;
	outTex0 = inTex;
}


//=====================================================================
// PixelShader: ڂ
//=====================================================================
float4 PS_Blur(float2 inTex0 : TEXCOORD0) : COLOR0
{

	float4 ret;

	ret =  tex2D(sampler0, inTex0) * fWeights[0];
	ret += (tex2D(sampler0, inTex0 + vOffsets[1]) + tex2D(sampler0, inTex0 - vOffsets[1])) * fWeights[1];
	ret += (tex2D(sampler0, inTex0 + vOffsets[2]) + tex2D(sampler0, inTex0 - vOffsets[2])) * fWeights[2];
	ret += (tex2D(sampler0, inTex0 + vOffsets[3]) + tex2D(sampler0, inTex0 - vOffsets[3])) * fWeights[3];
	ret += (tex2D(sampler0, inTex0 + vOffsets[4]) + tex2D(sampler0, inTex0 - vOffsets[4])) * fWeights[4];
	ret += (tex2D(sampler0, inTex0 + vOffsets[5]) + tex2D(sampler0, inTex0 - vOffsets[5])) * fWeights[5];
	ret += (tex2D(sampler0, inTex0 + vOffsets[6]) + tex2D(sampler0, inTex0 - vOffsets[6])) * fWeights[6];
	ret += (tex2D(sampler0, inTex0 + vOffsets[7]) + tex2D(sampler0, inTex0 - vOffsets[7])) * fWeights[7];


/*
	float4 ret;

	ret = tex2D(sampler0, inTex0);
	ret += tex2D(sampler0, inTex0 + vTexOffset[0]);
	ret += tex2D(sampler0, inTex0 + vTexOffset[1]);
	ret += tex2D(sampler0, inTex0 + vTexOffset[2]);
	ret += tex2D(sampler0, inTex0 + vTexOffset[3]);
	ret += tex2D(sampler0, inTex0 + vTexOffset[4]);
	ret += tex2D(sampler0, inTex0 + vTexOffset[5]);
	ret += tex2D(sampler0, inTex0 + vTexOffset[6]);
	
	ret += tex2D(sampler0, inTex0 - vTexOffset[0]);
	ret += tex2D(sampler0, inTex0 - vTexOffset[1]);
	ret += tex2D(sampler0, inTex0 - vTexOffset[2]);
	ret += tex2D(sampler0, inTex0 - vTexOffset[3]);
	ret += tex2D(sampler0, inTex0 - vTexOffset[4]);
	ret += tex2D(sampler0, inTex0 - vTexOffset[5]);
	ret += tex2D(sampler0, inTex0 - vTexOffset[6]);

	ret = ret / 14;
*/
	return ret;
}


//=====================================================================
// PixelShader: ڂ()
//=====================================================================
float4 PS_BlurHalf(float2 inTex0 : TEXCOORD0,
				   float2 inTex1 : TEXCOORD1,
				   float2 inTex2 : TEXCOORD2,
				   float2 inTex3 : TEXCOORD3,
				   float2 inTex4 : TEXCOORD4,
				   float2 inTex5 : TEXCOORD5,
				   float2 inTex6 : TEXCOORD6,
				   float2 inTex7 : TEXCOORD7) : COLOR0
{
	return (tex2D(sampler0, inTex0) + 
			tex2D(sampler0, inTex1) + 
			tex2D(sampler0, inTex2) + 
			tex2D(sampler0, inTex3) + 
			tex2D(sampler0, inTex4) + 
			tex2D(sampler0, inTex5) + 
			tex2D(sampler0, inTex6) + 
			tex2D(sampler0, inTex7)) / 16.0;
}



//=====================================================================
// VertexShader: R|Wbg
//=====================================================================
void VS_Composite(float4			inPosition		: POSITION,
				  float2			inTex			: TEXCOORD,
				  out float4		outPosition		: POSITION,
				  out float2		outTex0			: TEXCOORD0)
{
	outPosition = inPosition;
	outTex0 = inTex;
}


//=====================================================================
// PixelShader: R|Wbg
//=====================================================================
float4 PS_Composite(float2			inTex:		TEXCOORD): COLOR0
{
	float4 ret = tex2D(sampler0, inTex) * 2.0;
	return ret * ret * 0.5;
}



technique GlowMap
{
	pass
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = TRUE;
		AlphaRef = 1;
		AlphaFunc = GREATEREQUAL;
		ZEnable = TRUE;
		VertexShader = compile vs_2_0 VS_GlowEffect();
		PixelShader = compile ps_2_0 PS_GlowEffect();
	}
}


technique Blur
{
	pass
	{
		CullMode = NONE;
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		ZEnable = FALSE;
		AddressU[0] = CLAMP;
		AddressV[0] = CLAMP;
		MinFilter[0] = LINEAR;
		MagFilter[0] = LINEAR;
		PixelShader = compile ps_2_0 PS_Blur();
		VertexShader = compile vs_1_1 VS_Blur();
	}
}


technique Composite
{
	pass
	{
		CullMode = NONE;
		AlphaBlendEnable = TRUE;
		AlphaTestEnable = FALSE;
		ZEnable = FALSE;
		AddressU[0] = CLAMP;
		AddressV[0] = CLAMP;
		MinFilter[0] = LINEAR;
		MagFilter[0] = LINEAR;
		SrcBlend = ONE;
		DestBlend = ONE;
		VertexShader = compile vs_2_0 VS_Composite();
		PixelShader = compile ps_2_0 PS_Composite();
	}
}

