float4x4		mView;
float4x4		mProj;
float4x4		mViewProj;
float3			vLow;
float3			vHigh;


samplerCUBE sSkyCube;


void VS_SkySphere(
	float4		inPosition		: POSITION,
	float3		inNormal		: NORMAL,
	out float4	outPosition		: POSITION,
	out float4	outColor		: COLOR0,
	out float3	outTex			: TEXCOORD0
)
{

	float4 scale = {200, 200, 200, 1};
	float4 offset = {0, 0, 500, 0};

	float3 pos = mul(inPosition * scale, (float3x3)mView);

	outPosition = mul(float4(pos, 1) + offset, mProj);
	
	float3 normal = inNormal;
	
	outTex = normal;
	
	outColor = float4(vLow + inPosition.y * (vHigh - vLow), 1);

}


float4 PS_SkySphere(float3 inTex : TEXCOORD0, float4 inColor : COLOR0) : COLOR
{
	return texCUBE(sSkyCube, inTex) * inColor;
}


technique
{

	pass
	{
	
		//FillMode = WIREFRAME;
		AlphaBlendEnable = false;
		CullMode = CW;
		ZEnable = false;
		MagFilter[0] = LINEAR;
		MinFilter[0] = LINEAR;
		AddressU[0] = CLAMP;
		AddressV[0] = CLAMP;
		VertexShader = compile vs_1_1 VS_SkySphere();
		//PixelShader = compile ps_2_0 PS_SkySphere();
	}

}

