shared float4x4		mView;
shared float4x4		mProj;
shared float4x4		mViewProj;
shared float3		vViewPosition;
shared float		fFogStart;
shared float		fFogEnd;
shared bool			bFogEnable;


float4x4			mWorld;
float4x4			mWorldViewProj;
float4x4			mWorldView;
float4				vTextureScale = {1, 1, 0, 0};
float4				vBgColor = {0, 0, 0, 1};
//float4			vViewDirection;
texture				tEnvMap;


samplerCUBE sCubeRefraction = sampler_state { Texture = <tEnvMap>; };


//==============================================================================
// L[u̔wip̒_VF[_[
//==============================================================================
void VS_Transform(
	float4		inPosition	: POSITION,
	float3		inNormal	: NORMAL,
	float2		inTex0		: TEXCOORD0,
	out float4	outPosition	: POSITION,
	out float4	outDiffuse	: COLOR0,
	out float2	outTex		: TEXCOORD0,
	out float	outFog		: FOG
)
{
	float4 pos = mul(inPosition, mWorld);

	// Wϊ
	outPosition = mul(pos, mViewProj);
	
	// eNX`W𒲐
	outTex = inTex0 * vTextureScale;

	// fBt[Y
	outDiffuse = vBgColor;

	// tHO
	outFog = (fFogEnd - length((float3)pos - vViewPosition)) / (fFogEnd - fFogStart);
}




//==============================================================================
// L[u̔˃fJ[p̒_VF[_[
//==============================================================================
void VS_CubeRefraction(
	float4 inPosition		: POSITION,
	float3 inNormal			: NORMAL,
	out float4 outPosition	: POSITION,
	out float3 outTex		: TEXCOORD0
)
{
	float4 worldPos = mul(inPosition, mWorld);

	outPosition = mul(worldPos, mViewProj);

	// @xNgJԂɈړ
	float3 normal = normalize(mul(inNormal, mWorldView));
	
	// JZʒũoCAX
	// float3 bias = {0, 0, 0};//1000};
	
	// JԂł̒_WvZ
	float3 scale = {1, 1, 0.2};
	
	// JԂ܂ł̒_WxNgɂ
	float3 eyeRay = normalize(mul(inPosition, mWorldView) * scale);
	
	outTex = reflect(eyeRay, normal);
/*	

	// R = 2 (E dot N) N - E
	float3 N = -normalize(mul(inNormal, (float3x3)mWorldView));
	
	float3 E = {0, 0, 0};
	E = normalize(mul(E, mView) - (float3)mul(inPosition, mWorld));
	
	outTex = 2.0 * dot(E, N) * N - E;
	
*/
}


//==============================================================================
// L[u̔˃fJ[p̃sNZVF[_[
//==============================================================================
float4 PS_CubeRefraction(float3 tex : TEXCOORD0) : COLOR
{
	float4 brightness = {0.1, 0.1, 0.1, 1.0};
	return texCUBE(sCubeRefraction, tex) * brightness;
}





technique
{
	pass
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		ZFunc = LESSEQUAL;
		FogEnable = bFogEnable;
		SpecularEnable = False;
		VertexShader = compile vs_1_1 VS_Transform();
		PixelShader = NULL;
	}
	
	pass
	{
		AlphaBlendEnable = True;
		SrcBlend = ONE;
		DestBlend = ONE;
//		MagFilter[0] = LINEAR;
//		MinFilter[0] = LINEAR;
		MagFilter[0] = POINT;
		MinFilter[0] = POINT;
		AddressU[0] = CLAMP;
		AddressV[0] = CLAMP;
		VertexShader = compile vs_1_1 VS_CubeRefraction();
		PixelShader = compile ps_2_0 PS_CubeRefraction();
	}

}


