
static const int		MAX_MATRICES = 16;				// s̍ő吔
bool					bEnableSkinning = false;		// XLjO
float4x4				mBoneMatrices[MAX_MATRICES];	// {[̍s
bool					bVertexColorEnable = false;		// F̗L
float4					vConstantColor;					// F
bool					bEnableEnvMapping = false;		// }bsO

shared float3			vViewPosition;
shared float4x4			mView;
shared float4x4			mViewProj;
shared float			fFogStart;
shared float			fFogEnd;
shared bool				bFogEnable;

float4x4				mWorld;




//==============================================================================
// _VF[_[
//==============================================================================
void VS_Transform(
	float4		inPosition	: POSITION,
	float3		inNormal	: NORMAL,
	float3		inColor		: COLOR0,
	float2		inTex		: TEXCOORD0,
	float3		inWeights	: BLENDWEIGHT,
	float4		inIndices	: BLENDINDICES,
	out float4	outPosition	: POSITION,
	out float3	outColor	: COLOR0,
	out float2	outTex		: TEXCOORD0,
	out float	outFog		: FOG
)
{
	float4 worldPos;
	
	// XLjO̗LŃu`
	if (bEnableSkinning)
	{
		worldPos = mul(inPosition, mBoneMatrices[inIndices.x]) * inWeights.x + 
					mul(inPosition, mBoneMatrices[inIndices.y]) * inWeights.y + 
					mul(inPosition, mBoneMatrices[inIndices.z]) * inWeights.z + 
					mul(inPosition, mBoneMatrices[inIndices.w]) * (1.0 - inWeights.x - inWeights.y - inWeights.z);
		worldPos = mul(worldPos, mWorld);
	}
	else
	{
		worldPos = mul(inPosition, mWorld);
	}

	// ʒu
	outPosition = mul(worldPos, mViewProj);

	// _J[
	if (bVertexColorEnable)
	{
		outColor = inColor;
	}
	else
	{
		outColor = vConstantColor;
	}

	// tHO
	if (bFogEnable)
	{
		outFog = (fFogEnd - length((float3)worldPos - vViewPosition)) / (fFogEnd - fFogStart);
	}
	else
	{
		outFog = 0;
	}

	// eNX`W
	if (bEnableEnvMapping)
	{
		outTex = mul(inNormal, mView);
	}
	else
	{
		outTex = inTex;
	}
}


technique
{
	pass
	{
		FogEnable = bFogEnable;
		CullMode = NONE;
		AlphaTestEnable = TRUE;
		AlphaRef = 1;
		AlphaFunc = GREATEREQUAL;
		VertexShader = compile vs_2_0 VS_Transform();
	}
}

