shared float4x4		mViewProj;

float4x4			mWorld;
float4				vScale;


void VS_Transform(float4		inPosition		: POSITION,
				  float4		inColor			: COLOR0,
				  float2		inTex			: TEXCOORD0,
				  out float4	outPosition		: POSITION,
				  out float4	outColor		: COLOR0,
				  out float2	outTex			: TEXCOORD0)
{
	outPosition = mul(mul(inPosition * vScale, mWorld), mViewProj);
	outColor = inColor;
	outTex = inTex;
}


technique
{
	pass
	{
		ZWriteEnable = FALSE;
		AlphaBlendEnable = TRUE;
		SrcBlend = ONE;
		DestBlend = ONE;
		AlphaTestEnable = FALSE;
		MagFilter[0] = LINEAR;
		MinFilter[0] = LINEAR;
		AlphaOp[0] = MODULATE;
		VertexShader = compile vs_1_1 VS_Transform();
	}
}

