float4x4			mWorldViewProj : WorldViewProjection;
texture				tColorTexture;
texture				tNoiseTexture;
float				fTimer : TIME;
sampler2D			textureSampler = sampler_state { texture = <tColorTexture>; };
sampler2D			noiseSampler = sampler_state { texture = <tNoiseTexture>; };


void mainVS(float3 inPos		: POSITION, 
			float2 tex0			: TEXCOORD0,
			float2 tex1			: TEXCOORD1,
			out float4 outPos	: POSITION,
			out float2 outTex0	: TEXCOORD0,
			out float2 outTex1	: TEXCOORD1)
{	
	float a = fTimer;
	float3 v = inPos/* * float3(1, 1 + a, 1)*/ + float3(0, a * 2.0, 0);

	outPos = mul(float4(v, 1), mWorldViewProj);
	outTex0 = tex0;
	outTex1 = tex1;
}


float4 mainPS(float2 inTex0 : TEXCOORD0, 
			  float2 inTex1 : TEXCOORD1) : COLOR 
{
	float4 t = tex2D(textureSampler, inTex0);
	float4 noise = tex2D(noiseSampler, inTex1);
	
	float4 a = fTimer * 3.0;
	
	return float4(t.rgb + a.rgb, t.a * noise.a - a.a);
}


technique technique0 {
	pass p0 {
		AlphaTestEnable = TRUE;
		AlphaRef = 1;
		AlphaFunc = GREATEREQUAL;
		CullMode = None;
		//AlphaBlendEnable = TRUE;
		SrcBlend = ONE;
		DestBlend = ONE;
		VertexShader = compile vs_1_1 mainVS();
		PixelShader = compile ps_2_0 mainPS();
	}
}
