shared float3		vViewPosition;
shared float4x4		mViewProj;
shared float		fFogStart;
shared float		fFogEnd;
shared bool			bFogEnable;
float4x4			mWorld;
float				fLength;


//==============================================================================
// _VF[_[
//==============================================================================
void VS_Transform(
	float4		inPosition	: POSITION,
	float		inWeight	: BLENDWEIGHT0,
	float3		inNormal	: NORMAL,
	out float4	outPosition	: POSITION,
	out float4	outColor	: COLOR0,
	out float	outFog		: FOG
)
{
	float t;

	t = min(1.0 - fLength + inWeight, 1);

	float4 pos = mul(inPosition + float4(normalize(inNormal) * -t, 0), mWorld);
	outPosition = mul(pos, mViewProj);

	//float3 lightDir = {-0.7, -0.7, 0};
	//float r = dot(inNormal, lightDir) * 0.5 + 0.5;
	outColor.x = 1;
	outColor.y = 1;
	outColor.z = 1;
	outColor.w = 1 - t;
	
	outFog = (fFogEnd - length((float3)pos - vViewPosition)) / (fFogEnd - fFogStart);
}


technique
{
	pass
	{
		FogEnable = bFogEnable;
		CullMode = NONE;
		AlphaTestEnable = TRUE;
		AlphaFunc = GREATEREQUAL;
		AlphaRef = 8;
		AlphaArg1[0] = DIFFUSE;

		VertexShader = compile vs_1_1 VS_Transform();
	}
}

